
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SESSION_MANAGER_H
#define PG_SESSION_MANAGER_H

#include "xstd/AlarmClock.h"
#include "client/SessionStats.h"

class Client;
class CltCfg;
class CltXact;
class SessionHeartbitMgr;

class SessionMgr: public AlarmUser {
	public:
		SessionMgr(Client *anOwner);
		virtual ~SessionMgr();

		void configure(const CltCfg *aCfg);

		void start();
		void delayedStart(Time delay);
		void stop();

		void noteXactDone(CltXact *x);
		void noteXactErr(CltXact *x);

		virtual void wakeUp(const Alarm &a);
		virtual void bitHeart();

		bool idle() const { return isIdle; }

	protected:
		void stopHeartbit();

		void becomeBusy();
		void becomeIdle();
		void checkPoint();

	protected:
		Client *theOwner;
		const CltCfg *theCfg;
		SessionHeartbitMgr *theHeartbitMgr;
		SessionStats theStats;
		bool isIdle;
};

#endif
