
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_BODY_ITERATOR_H
#define PG_BODY_ITERATOR_H

#include "xstd/Rnd.h"
#include "base/ObjId.h"

class WrBuf;

class BodyIter {
	public:
		BodyIter();
		virtual ~BodyIter();

		virtual void reset();

		void oid(const ObjId &anOid) { theOid = anOid; }
		virtual void configure(WrBuf *aBuf, Size aContSize);
		virtual void stop() {}

		const ObjId &oid() const { return theOid; }
		Size builtSize() const { return theBuiltSize; }
		Size offSeed() const { return theOid.hash(); }

		virtual void pour() = 0;  // fills the buffer

		operator void *() const { return theBuiltSize < theContSize ? (void*)-1 : 0; }

	protected:
		Size sizeLeft() const { return theContSize - theBuiltSize; }

	protected:
		ObjId theOid;  // XXX: replace with a pointer when ObjRec is removed
		WrBuf *theBuf;
		RndGen theRng;
		Size theContSize;

		Size theBuiltSize;
};

#endif
