
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_ICP_BASE_CLASS_H
#define PG_ICP_BASE_CLASS_H

#include "xstd/NetAddr.h"
#include "xstd/Socket.h"
#include "xstd/FileScanner.h"

class IcpMsg;

// base class for ICP clients and servers
class IcpBase: FileScanUser {
	public:
		virtual ~IcpBase();

		void configure(const NetAddr &aHost);

		Socket &socket() { return theSock; }

		virtual void start();

		virtual void noteReadReady(int fd);

	protected:
		// both call noteUnexpMsg
		virtual void noteRequest(const IcpMsg &m);
		virtual void noteReply(const IcpMsg &m);

		void noteUnexpMsg(const IcpMsg &m);
		virtual int logCat() const = 0;

	protected:
		NetAddr theHost;
		Socket theSock;
		FileScanReserv theReserv;
};

#endif
