
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "pgl/pgl.h"

#include "xstd/String.h"
#include "pgl/PglRec.h"
#include "pgl/DumperSym.h"


DumperSym::DumperSym(): RecSym("Dumper", new PglRec) {

	// add fields

	theRec->bAdd("bool", "req_hdrs", 0);
	theRec->bAdd("bool", "rep_hdrs", 0);
}

DumperSym::DumperSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool DumperSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Dumper";
}

SynSym *DumperSym::dupe(const String &type) const {
	if (isA(type))
		return new DumperSym(this->type(), theRec->clone());
	return RecSym::dupe(type);
}
