
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PGL_NET_ADDRESS_RANGE_SYMBOL_H
#define PGL_NET_ADDRESS_RANGE_SYMBOL_H

#include "pgl/PglContainerSym.h"

class PglNetAddrRange;

// a compact representation of a range of addresses
class NetAddrRangeSym: public ContainerSym {
	public:
		NetAddrRangeSym();
		virtual ~NetAddrRangeSym();

		virtual bool isA(const String &type) const;

		virtual int count() const;
		virtual bool probsSet() const;
		virtual const SynSym *itemProb(int offset, double &prob) const;

		void range(PglNetAddrRange *aRange) { theRange = aRange; }

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		virtual SynSym *dupe(const String &type) const;

	protected:
		PglNetAddrRange *theRange;
		mutable NetAddrSym *theAddr; // cache for itemProb()
};

#endif
