
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_PROXY_SERVER_XACTION_H
#define PG_PROXY_SERVER_XACTION_H

#include "server/SrvXact.h"
#include "cache/Cache.h"

class PxySrvXact: public SrvXact, public CacheReader {
	public:
		PxySrvXact() { PxySrvXact::reset(); }
		virtual void reset();

		virtual void noteWriteReady(int fd);
		virtual void noteWriterLeft();
		virtual void noteCacheReady();
		virtual const ReqHdr *origReqHdrs() const;

	protected:
		virtual Size put200OkHead(ostream &os);
		virtual Error setTarget(const NetAddr &target);
		virtual void newState(State aState);

		Size put200OkHit(ostream &os);
		Size put200OkMiss(ostream &os);

	protected:
		bool waitForCache;
};

#endif

