
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "xstd/h/iostream.h"
#include "xstd/h/iomanip.h"

#include "xstd/Clock.h"
#include "runtime/LogComment.h"

#include "runtime/PolyOLog.h"
#include "base/polyLogCats.h"
#include "base/polyLogTags.h"
#include "xstd/gadgets.h"
#include "runtime/globals.h"

int LogComment::TheEchoLevel = 0;
int LogComment::TheCurLevel = 0;
char LogComment::TheBuf[8*1024];

LogComment Comment; // note: assumes Comment is not used in static-ctors

LogComment::LogComment(): ostrstream(TheBuf, sizeof(TheBuf)) {
	configureStream(*this, 2);
}

ostream &endc(ostream &os) {
	os << ends;
	TheOLog << bege(lgComment, lgcAll) << Comment.str() << ende;
	if (Comment.TheCurLevel <= Comment.TheEchoLevel) {
		cout 
			<< setfill('0') << setw(6) << (TheClock.runTime().secd()/60)
			<< setfill(' ')	<< "| "
			<< Comment.str() << endl;
	}
	Comment.reset();
	return os; 
}
