
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_STATS_SAMPLING_MANAGER_H
#define PG_STATS_SAMPLING_MANAGER_H

#include "xstd/Array.h"
#include "xstd/AlarmClock.h"

class StatsSampleSym;
class StatsSampleCfg;

// schedules an initiates sampling

class StatsSampleMgr: public AlarmUser {
	public:
		StatsSampleMgr();
		virtual ~StatsSampleMgr();

		void configure(const Array<StatsSampleSym*> &cfgs);
		void addSample(const StatsSampleCfg &cfg);
		void willAddSample();

		void start();

		virtual void wakeUp(const Alarm &);

		void reportCfg(ostream &os) const;

	protected:
		void schedSample(const StatsSampleCfg &cfg);
		void startSample();

	protected:
		Array<StatsSampleCfg*> theCfgs;
		int theStartCnt;     // how many samples were started
		int thePendCfgCnt;   // how many cfgs will be addeded
};

extern StatsSampleMgr TheStatsSampleMgr;

#endif
