
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "base/polygraph.h"

#include "runtime/polyErrors.h"

const Error errForeignReq = Error::Add("foreign HTTP request");
const Error errForeignRep = Error::Add("foreign HTTP reply");
const Error errIcpForeignReq = Error::Add("foreign ICP request");
const Error errIcpForeignRep = Error::Add("foreign ICP reply");
const Error errMisdirRequest = Error::Add("misdirected request");
const Error errNoHostName = Error::Add("missing host name in the request");
const Error errForeignHostName = Error::Add("foreign host name");
const Error errBadHostName = Error::Add("failed to parse host name");
const Error errSrvRedirect = Error::Add("unexpected server redirection");
const Error errRedirLocation = Error::Add("bad redirect location");
const Error errForeignTarget = Error::Add("request for unknown origin server");
const Error errNoTarget = Error::Add("missing target info in the request");
const Error errPrematureEof = Error::Add("premature end of msg body");
const Error errPrematureEoh = Error::Add("premature end of msg header");
const Error errExtraRepData = Error::Add("extra reply data");
const Error errNoHdrClose = Error::Add("connection closed before sending headers");
const Error errHttpRLine = Error::Add("malformed HTTP request or response line");
const Error errHttpStatusCode = Error::Add("unsupported HTTP status code");
const Error errNoCLen = Error::Add("missing Content-Length header");
const Error errUnexpectedCLen = Error::Add("unexpected Content-Length header");
const Error errHttpNoDate = Error::Add("missing Date: header field");
const Error errSyncDate = Error::Add("clocks out of sync");
const Error errHugeHdr = Error::Add("HTTP header is too big");
const Error errUnchbHit = Error::Add("hit on uncachable object");
const Error err1UseHit = Error::Add("hit on first request to an object");
const Error errReloadHit = Error::Add("hit on reload request");
const Error errStaleHit = Error::Add("stale object");
const Error errZeroFDLimit = Error::Add("zero filedescriptor limit?!");
const Error errChbChange = Error::Add("cachability status changed");
const Error errFalseHit = Error::Add("false hit");
const Error errServerGone = Error::Add("server had to terminate");
const Error errLogBufFull = Error::Add("log buffer is full");
const Error errUnclaimOid = Error::Add("an advertised oid has not been requested for a while");
const Error errUnsolicOid = Error::Add("a non-advertised oid has been requested");
const Error errNoNewOids = Error::Add("client ran out of new public oids");
const Error errFidFlood = Error::Add("cannot send failed oids to servers fast enough");
const Error errNidReqFlood = Error::Add("server received too many requests for new oids");
const Error errNidRepFlood = Error::Add("client received too many new oids");
const Error errNidStoreLimit = Error::Add("new oid storage cannot grow any more");
const Error errSrvChangedWid = Error::Add("client discovered server world id change");
const Error errUnreachContType = Error::Add("unreachable content type");
const Error errForeignTag = Error::Add("foregn content <tag>");
const Error errMalformedTag = Error::Add("malformed content <tag>");
const Error errOpenTag = Error::Add("open content <tag"); // vs. unbalanced
const Error errTooManyWaitXact = Error::Add("too many postponed xactions");
const Error errTimingDrift = Error::Add("internal timers may be getting behind");
const Error errSiblingViolation = Error::Add("violation of a sibling relationship");
const Error errMake302Found = Error::Add("``302 Found'' reply generation failed");
const Error errUnderpopulated = Error::Add("cannot meet robot population goal");
const Error errChecksum = Error::Add("message content checksum mismatch");
const Error errConnectEstb = Error::Add("failed to establish a connection");

const Error errIcpRepCode = Error::Add("unsupported ICP opcode");
const Error errIcpVersion = Error::Add("unsupported ICP version");
const Error errIcpMsgSize = Error::Add("bad ICP message size");
const Error errIcpBadReqNum = Error::Add("bad ICP reqnum");
const Error errIcpRepOverlap = Error::Add("ICP client may have too many outstanding requests");
const Error errIcpUnexpMsg = Error::Add("unexpected message to an ICP agent");
const Error errIcpErrOpcode = Error::Add("got ICP reply with ICP_ERROR opcode");

const Error errDnsBadMsgId = Error::Add("DNServer responded with invalid message ID");
const Error errDnsAllSrvsFailed = Error::Add("all DNServers failed to resolve a domain name");
const Error errDnsRepTimeout = Error::Add("timedout waiting for DNServer response");
const Error errDnsRepMismatch = Error::Add("DNServer response does not match our query");
const Error errDnsRespFmt = Error::Add("failed to parse DNServer response");
const Error errDnsQueryFmt = Error::Add("DNServer failed to parse our query");
const Error errDnsSrvFail = Error::Add("DNServer failed to process our query");
const Error errDnsNoName = Error::Add("DNServer did not resolve domain name");
const Error errDnsNoSupp = Error::Add("DNServer does not support the requested operation");
const Error errDnsRefused = Error::Add("DNServer refused to process the query");
const Error errDnsRCode = Error::Add("unknown response code from DNServer");

const Error errOther = Error::Add("unclassified error");
