
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_SERVER_CONFIGURATION_H
#define PG_SERVER_CONFIGURATION_H

#include "xstd/Array.h"
#include "csm/ContentTypeIdx.h"

class ServerSym;
class PopModel;
class RndDistr;

// Server configuration items that can be shared among multiple servers
class SrvCfg: public ContentTypeIdx {
	public:
		SrvCfg();
		~SrvCfg();

		void configure(const ServerSym *aServer);

		Size selectAbortSize(Size clen);

	protected:
		void configureRepTypes();

	public:
		const ServerSym *theServer;  // used to identify/share configs
		PopModel *thePopModel;    // popularity model to repeat oids
		RndDistr *theRepTypeSel;  // selects reply types	
		double theAbortProb;
};


class SrvSharedCfgs: protected Array<SrvCfg*> {
	public:
		SrvCfg *getConfig(const ServerSym *cfg);

	protected:
		SrvCfg *addConfig(const ServerSym *cfg);
};

#endif
