
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#ifndef PG_XML_NODE_LIST_H
#define PG_XML_NODE_LIST_H

#include "xstd/Array.h"

class String;
class XmlAttr;
class XmlNode;

// a collection of XML nodes
class XmlNodes: public Array<XmlNode*> {
	public:
		typedef Array<XmlNode*> Parent;

	public:
		~XmlNodes();

		int selByAttrName(const String &name, XmlNodes &res);
		int selByAttrVal(const String &name, const String &value, XmlNodes &res);

		// sets the attribute for all nodes
		XmlNodes &operator <<(const XmlAttr &a);

		XmlNodes &operator <<(const XmlNode &n);
		XmlNodes &operator <<(const XmlNodes &ns);

		ostream &print(ostream &os, const String &pfx) const;
};

#endif
