
/*
 * Web Polygraph                        http://www.web-polygraph.org/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. See the COPYRIGHT file for details.
 */

#include "xstd/xstd.h"

#include <stdlib.h>
#include "xstd/h/math.h"
#include "xstd/Assert.h"
#include "xstd/NetDouble.h"


NetDouble::NetDouble(double x) {
	mnt = (int) floor(0x7fffffff * frexp(x, &exp));
}

NetDouble::operator double() const {
	// avoid floating point exceptions on overflows when we read
	// invalid data
	return abs(exp) <= 1024 ? ldexp(mnt/(double)0x7fffffff, exp) : -1;
}
